-- grant exec on xx_Change_DocAcc_Author_For_Task to public


CREATE procedure xx_Change_DocAcc_Author_For_Task
(
@Author int --   
,@Author_New int --   
)
with execute as owner
as

begin tran
--         
delete from SBEdocAcc where EDocID in (select ta.AttachID from SBTaskAttach ta where ta.AttachType = 'E' and ta.TaskID in (select XRecID from #new_author_task))  and AccountID = @Author_New

declare @EDocID int;
declare c_edoc cursor fast_forward read_only for
	select da.EDocID from SBEDocAcc da
		where da.EDocID in 
			(select ta.AttachID from SBTaskAttach ta where ta.AttachType = 'E' and ta.TaskID in (select XRecID from #new_author_task)) 
			and da.AccountID = @Author
open c_edoc	
DECLARE @Next int

fetch next from c_edoc into @EDocID;
while @@fetch_status = 0
begin
	EXECUTE XNextID @FldName = 'SB_EDocAccXRecID', @Next = @Next OUTPUT                      
	
	
	
	--             
	insert into SBEdocAcc (TypeID, EDocID, XRecID, Number, AccessType, AccountID) 
	select TypeID, EDocID, @Next, (select MAX(Number) from SBEdocAcc where EDocID = @EDocID) + 1 as Number,
                            AccessType, @Author_New as AccountID  
	from SBEdocAcc 
  where EDocID = @EDocID and AccountID = @Author;
	fetch next from c_edoc into @EDocID;                            
end
close c_edoc
deallocate c_edoc	
commit tran