CREATE procedure [dbo].[xx_Change_Folder_Executor_For_Job]
(
@Author int --   
,@Author_New int --   
)
with execute as owner
as
	declare 
		@Author_Folder int --     
		,@Author_New_Folder int --     
		
	set @Author_Folder = (
				select top  1 XRecID
				from SBFolder
				where FolderType = 'I'
					and Author = @Author
				)
		set @Author_New_Folder = (
				select top 1 XRecID
				from SBFolder
				where FolderType = 'I'
					and Author = @Author_New
				)
				
		update l
		set l.SourceID = @Author_New_Folder --           
		
		from SBLinks l
		inner join #new_executor_job t on t.Executor_new = @Author_New
			and l.DestType = 'J'
			and l.DestID = t.XRecID
		inner join SBFolder f on f.XRecID = l.SourceID
		where t.XRecID in (select XRecID from #new_executor_job)
			and l.SourceID = @Author_Folder
			and l.DestID not in (
				select DestID
				from SBLinks ll
				where ll.DestType = 'J'
					and ll.SourceID = @Author_New_Folder
				) --   SourceID, SourceType, DestID, DestType, SourceSystemCode ..          
